//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#include "ui\window.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CDropDownList : public CWindow
  {
   string            m_data[];
   int               m_selected_item;
   bool              m_mouse_key;

public:
                     CDropDownList();
                    ~CDropDownList();
   //---
   void              OnPaint(uint &buffer[],int width,int height);
   int               SetList(const string &data[]);
   bool              OnMouseMove(int x,int y,uint state);
   void              OnCreate() { m_mouse_key=false; m_selected_item=-1; }
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CDropDownList::CDropDownList(void):m_selected_item(-1),m_mouse_key(false)
  {
   m_color_format=COLOR_FORMAT_ARGB_NORMALIZE;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CDropDownList::~CDropDownList(void)
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CDropDownList::OnPaint(uint &buffer[],int width,int height)
  {
   ArrayInitialize(buffer,int(0xFFE0E0E0));
   ArrayFill(buffer,0,width,0x20000000);
   ArrayFill(buffer,(height-1)*width,width,0x10000000);
   ArrayFill(buffer,(height-2)*width,width,0x30000000);
   ArrayFill(buffer,(height-3)*width,width,0x50000000);

   for(int y=0;y<height;y++)
     {
      buffer[y*width]        =0x10000000;
      buffer[y*width+width-1]=0x10000000;
      if(y<height-2)
        {
         buffer[y*width+1]      =0x30000000;
         buffer[y*width+width-2]=0x30000000;
         if(y<height-3)
           {
            buffer[y*width+2]      =0x50000000;
            buffer[y*width+width-3]=0x50000000;
           }
        }
     }

   TextSetFont("Arial",-120);
   for(int i=0,y=1,n=ArraySize(m_data);i<n;i++,y+=20)
     {
      if(m_selected_item==i)
        {
         for(int j=1+m_selected_item*20,m=y+20;j<m;j++)
            ArrayFill(buffer,j*width+3,width-6,0xFF0000C0);
         TextOut(m_data[i],width-5,y,TA_RIGHT,buffer,width,height,0xFFF0F0F0,COLOR_FORMAT_ARGB_NORMALIZE);
        }
      else
         TextOut(m_data[i],width-5,y,TA_RIGHT,buffer,width,height,0xFF404040,COLOR_FORMAT_ARGB_NORMALIZE);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CDropDownList::SetList(const string &data[])
  {
   ArrayFree(m_data);
   ArrayCopy(m_data,data);
   return(ArraySize(m_data)*20);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CDropDownList::OnMouseMove(int x,int y,uint state)
  {
   x-=m_rect.x;
   y-=m_rect.y;
//---
   int selected=-1;
//---
   if(x>3 && x<m_rect.cx-6 && y>1 && y<ArraySize(m_data)*20+1)
     {
      selected=(y-2)/20;
     }
   else
      selected=-1;   
//---
   if((state&1)==1)
     {
      if(!m_mouse_key)
         m_mouse_key=true;
     }
   else
     {
      if(m_mouse_key)
        {
         NotifyParent(selected);
         Destroy();
        }
     }
//---
   if(m_selected_item!=selected)
     {
      m_selected_item=selected;
      Redraw();
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
