
#include "deftypes.mqh"
#include "frame.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CWindow : public CFrame
  {
protected:
   string            m_obj_name;
   string            m_rc_name;
   long              m_chart_id;
   uint              m_surface[];
   ENUM_COLOR_FORMAT m_color_format;
  
public:
                     CWindow();
                    ~CWindow();
   //---
   bool              Create(CFrame *parent,uint id,SRect &rc,long chart_id);
   void              Destroy();
   bool              IsVisible() { return(m_obj_name!=NULL); }
   virtual void      Redraw();
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CWindow::CWindow(void)
   :m_obj_name(NULL),m_rc_name(NULL),m_color_format(COLOR_FORMAT_XRGB_NOALPHA)
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CWindow::~CWindow(void)
  {
   Destroy();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CWindow::Create(CFrame *parent,uint id,SRect &rc,long chart_id)
  {
   m_id      =id;
   m_rect    =rc;
   m_chart_id=chart_id;
//---
   if(CheckPointer(parent))
      parent.AddChild(GetPointer(this));
//---
   if(m_obj_name==NULL)
     {
      m_obj_name="WND_"+(string)GetTickCount()+(string)rand();
      m_rc_name="::"+m_obj_name;
      
      ObjectCreate(chart_id,m_obj_name,OBJ_BITMAP_LABEL,0,0,0);
      ObjectSetString(chart_id,m_obj_name,OBJPROP_BMPFILE,m_rc_name);            
     }
//---
   ArrayResize(m_surface,rc.cx*rc.cy);
   ObjectSetInteger(chart_id,m_obj_name,OBJPROP_XDISTANCE,rc.x);
   ObjectSetInteger(chart_id,m_obj_name,OBJPROP_YDISTANCE,rc.y);
//---
   OnCreate();
   OnPaint(m_surface,rc.cx,rc.cy);
   ResourceCreate(m_rc_name,m_surface,rc.cx,rc.cy,0,0,rc.cx,COLOR_FORMAT_ARGB_NORMALIZE);   
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CWindow::Redraw(void)
  {
   OnPaint(m_surface,m_rect.cx,m_rect.cy);
   ResourceCreate("::"+m_obj_name,m_surface,m_rect.cx,m_rect.cy,0,0,m_rect.cx,m_color_format);
   ChartRedraw(m_chart_id);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CWindow::Destroy(void)
  {
   CFrame::Destroy();
//---
   if(m_obj_name!=NULL)
     {
      ObjectDelete(m_chart_id,m_obj_name);
      m_obj_name=NULL;
     }
//---
   if(m_rc_name!=NULL)
     {
      ResourceFree(m_rc_name);
      m_rc_name=NULL;
     }
//---
   ArrayFree(m_surface);   
  }
//+------------------------------------------------------------------+
